package com.jasamedika.medifirst2000.converter;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import org.springframework.stereotype.Component;

import com.google.gson.Gson;
import com.jasamedika.medifirst2000.converter.base.BaseVoConverter;
import com.jasamedika.medifirst2000.dao.custom.base.impl.FindConverterDao;
import com.jasamedika.medifirst2000.entities.OrderPelayanan;
import com.jasamedika.medifirst2000.vo.OrderPelayananVO;

/**
 * Converter class PAPSirkulasi
 * 
 * @author Askur
 */
@Component
public class OrderPelayananConverter extends FindConverterDao implements
		BaseVoConverter<OrderPelayananVO, OrderPelayanan> {

	public OrderPelayanan transferVOToModel(OrderPelayananVO vo, OrderPelayanan model) {
		if (null == model)
			model = new OrderPelayanan();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = vo.serialize(fieldsToInclude,vo.getClass().getName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        model = gson.fromJson(json, OrderPelayanan.class);
		} catch (Exception e) {
			e.printStackTrace();
		}

		return model;

	}

	public List<OrderPelayananVO> transferListOfModelToListOfVO(List<OrderPelayanan> models,
			List<OrderPelayananVO> vos) {
		if (null == vos)
			vos = new ArrayList<OrderPelayananVO>();

		if (null == models)
			return vos;

		for (OrderPelayanan model : models) {
			OrderPelayananVO vo = new OrderPelayananVO();
			transferModelToVO(model, vo);
			vos.add(vo);
		}

		return vos;
	}

	public OrderPelayananVO transferModelToVO(OrderPelayanan model, OrderPelayananVO vo) {
		if (null == vo)
			vo = new OrderPelayananVO();

		try {
			String[] fieldsToInclude = null;
			Map<String, Object> serialized = model.serialize(fieldsToInclude,model.getClass().getSimpleName());
			Gson gson = new Gson();
	        String json = gson.toJson(serialized);
	        vo = gson.fromJson(json, OrderPelayananVO.class);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return vo;
	}
	
}
